#
# $Id: amrita_publisher_test.rb,v 1.1 2004/01/17 12:02:25 hn Exp $
# Copyright Narushima Hironori. All rights reserved.
#

project_dir = File.dirname(__FILE__).sub(/(com.narucy.webpub.core).+/, '\1')
Dir.chdir project_dir
$: << project_dir + '/scripts/lib'

require 'ftools'
require 'test/unit'
require 'webpub/rftools'
require 'webpub/publisher'
require 'webpub/publish_manager'

=begin

=end
class AmritaPublisherTest < Test::Unit::TestCase

	def setup
		@proj_location = 'test_resources/webproject001'
		@tmpdir = ENV['TEMP'] + '/amrita_publisher_test' + rand(999).to_s
		File.cp_all(@proj_location, @tmpdir)
	end

	def test_publish_by_amrita
		config = ENV['TEMP'] + '/pubprop'
		begin
			open(config, 'w') { |fh|
				fh << ['amrita', File.dirname(__FILE__) + '/amrita_publisher.rb', 'WebPub::AmritaPublisher'].join(',')
			}
			manager = WebPub::PublishManager.new(config)
			manager.publish( Dir.glob(@tmpdir + '/ht_sources/*.html') )
		ensure
			File.delete config
		end
		assert %r!2001/01/01! === IO.readlines( @tmpdir + '/public_html/home.html').join
		assert %r!2002/02/02! === IO.readlines( @tmpdir + '/public_html/home2.html').join
		assert %r!2003/03/03! === IO.readlines( @tmpdir + '/public_html/foo/home.html').join
	end

	def teardown
		begin
			File.rm_all(@tmpdir)
		rescue
		end
	end

end
